#
# Created by Yi MIN<yi@zen.ly>
# Copyright © 2017 Zenly. All rights reserved.
#
# Patch or add methods for Bridge. Called by Element instance or Bridge instance
require 'pry'

Selenium::WebDriver::Remote::Bridge.class_eval do

  # # Add status method
  # def session_status
  #   execute :session_status
  # end

  # Add element_rect method
  def element_rect(element)
    data = execute :get_element_rect, id: element
    return data
  end

  # Add element_scroll method
  def scroll_element(element, direction)
    execute :scroll_element, {id: element}, {direction: direction}
  end

  def element_location(element)
    data = execute :get_element_rect, id: element

    Selenium::WebDriver::Point.new data['x'], data['y']
  end

  def element_size(element)
    data = execute :get_element_rect, id: element

    Selenium::WebDriver::Dimension.new data['width'], data['height']
  end

  # # Patch Bridge element_attribute method
  # def element_attribute(element, name)
  #   execute :get_element_attribute, id: element['ELEMENT'], name: name
  # end

  # # Add get_page_source method with accept_type to Bridge 
  # def source(accept_type)
  #   if accept_type == 'json'
  #     execute :get_page_source_json
  #   elsif accept_type == 'xml'
  #     execute :get_page_source_xml
  #   else
  #     raise "Unknown source type. Only 'xml' and 'json' source types are supported."
  #   end
  # end

  # # Add missing bindings
  # # https://github.com/facebook/WebDriverAgent/blob/master/WebDriverAgentLib/Commands/FBElementCommands.m
  # # Add tap_element method
  # def tap_element(element)
  #   execute :click_element, id: element['ELEMENT']
  # end

  # # Add double_tap_element method
  # def double_tap_element(element)
  #   execute :double_click_element, id: element['ELEMENT']
  # end

  # # Add two_finger_tap_element method
  # def two_finger_tap_element(element)
  #    execute :two_finger_click_element, id: element['ELEMENT']
  # end

  # # Add touch_and_hold_element method
  # def touch_and_hold_element(element)
  #   execute :touch_and_hold, id: element['ELEMENT']
  # end


  # # Add drag_from_to_for_duration method
  # def drag_from_to_for_duration(element, toX, toY, duration = 0)
  #   el_location = element_location(element)
  #   fromX = el_location[:x]
  #   fromY = el_location[:y]
  #   execute :drag_from_to_for_duration, {id: element['ELEMENT']}, { fromX: fromX, toX: toX, fromY: fromY, toY: toY, duration: duration }
  # end

  # # Add single tap method
  # def tap(x,y, element = nil)
  #   if element.nil?
  #     execute :tap, {id: 0}, { x: x, y: y }
  #   else
  #     execute :tap, {id: element['ELEMENT']}, { x: x, y: y }
  #   end 
  # end
    
  # # Add double tap method
  # def double_tap(x,y)
  #   execute :double_tap, {}, { x: x, y: y }  
  # end

  # def touch_and_hold(x, y)
  #   execute :touch_and_hold, {}, { x: x, y: y }  
  # end

end