#
# Created by Yi MIN<yi@zen.ly>
# Copyright © 2017 Zenly. All rights reserved.
#

module Selenium
  module WebDriver
    module Remote
      class Bridge
        #
        # http://www.w3.org/TR/2015/WD-webdriver-20150918/#list-of-endpoints
        #
        patched_commands = {
          get_page_source_json: [:get, 'source/json'.freeze],
          get_page_source_xml: [:get, 'source/xml'.freeze],
          session_status: [:get, 'status'.freeze],
          get_element_rect: [:get, 'session/:session_id/element/:id/rect'.freeze],
          is_element_accessible: [:get, 'session/:session_id/element/:id/accessible'.freeze],
          element_accessibility_container: [:get, 'session/:session_id/element/:id/accessibilityContainer'.freeze],
          double_click_element: [:post, 'session/:session_id/element/:id/doubleTap'.freeze],
          two_finger_click_element: [:post, 'session/:session_id/element/:id/twoFingerTap'.freeze],
          touch_and_hold_element: [:post, 'session/:session_id/element/:id/touchAndHold'.freeze],
          scroll_element: [:post, 'session/:session_id/uiaElement/:id/scroll'.freeze],
          drag_from_to_for_duration: [:post, 'session/:session_id/uiaTarget/:uuid/dragfromtoforduration'.freeze],
          tap: [:post, 'session/:session_id/doubleTap/:id'.freeze],
          tap_and_hold: [:post, 'session/:session_id/touchAndHold'.freeze],
          double_tap: [:post, 'session/:session_id/doubleTap'.freeze]
        }
        
        PATCHED_COMMANDS = patched_commands.merge!(COMMANDS).freeze

        def commands(command)
          PATCHED_COMMANDS[command]
        end
      end
    end # Remote
  end # WebDriver
end # Selenium