#
# Created by Yi MIN<yi@zen.ly>
# Copyright © 2017 Zenly. All rights reserved.
#

# require 'selenium-webdriver'

# Patch or add methods for Element instance
Selenium::WebDriver::Element.class_eval do 
  def id
    ref
  end

  # Scroll on an element with its id
  # @param id [String], direction [String] up, down, left, right
  # @return {}
  def scroll(direction)
    bridge.element_scroll self, direction
  end

  # Get wdRect by id
  # @param id [String] Element uuid
  # @return rect [Hash] location: y, x, size: width, height 
  def rect
    bridge.element_rect @id
  end

  # Get element type attribute
  # @return [String] example: "XCUIElementTypePageIndicator", "XCUIElementTypeButton"
  def tag_name
    bridge.element_tag_name @id
  end

  # Get element value attribute
  def value
    bridge.element_attribute self, 'value'
  end

  # Get element name attribute
  def name
    bridge.element_attribute self, 'name'
  end

  # Get element name attribute
  def label
    bridge.element_attribute self, 'label'
  end

  # Get the value of a the given attribute of the element.
  # @param [String]
  #   attribute name, example: type, label, name, value, rect
  # @return [String,nil]
  #   attribute value
  def attribute(name)
    bridge.element_attribute self, name
  end

end